glibmm: Gio::AsyncResult Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::AsyncResult Class Reference

Provides a base class for implementing asynchronous function results. More...

`#include <giomm/asyncresult.h>`

Inheritance diagram for Gio::AsyncResult:
[legend]

## Public Member Functions
virtual | ~AsyncResult ()
GAsyncResult* | gobj ()
| Provides access to the underlying C GObject. More...
const GAsyncResult* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< Glib::Object > | get_source_object ()
| Gets the source object from a AsyncResult. More...
Glib::RefPtr< const Glib::Object > | get_source_object () const
| Gets the source object from a AsyncResult. More...
Glib::RefPtr< Glib::ObjectBase > | get_source_object_base ()
Glib::RefPtr< const Glib::ObjectBase > | get_source_object_base () const
bool | is_tagged (gpointer source_tag) const
| Checks if res has the given source_tag (generally a function pointer indicating the function res was created by). More...
virtual Glib::RefPtr < Glib::ObjectBase > | get_source_object_vfunc ()
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| AsyncResult ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::AsyncResult > | wrap (GAsyncResult* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Provides a base class for implementing asynchronous function results.

Asynchronous operations are broken up into two separate operations which are chained together by a SlotAsyncReady. To begin an asynchronous operation, provide a SlotAsyncReady to the asynchronous function. This callback will be triggered when the operation has completed, and will be passed an AsyncResult instance filled with the details of the operation's success or failure, the object the asynchronous function was started for and any error codes returned. The asynchronous callback function is then expected to call the corresponding "_finish()" function with the object the function was called for, and the AsyncResult instance.

The purpose of the "_finish()" function is to take the generic result of type AsyncResult and return the specific result that the operation in question yields (e.g. a FileEnumerator for an "enumerate children" operation). If the result or error status of the operation is not needed, there is no need to call the "_finish()" function and GIO will take care of cleaning up the result and error information after the SlotAsyncReady returns. You may also store the AsyncResult and call "_finish()" later.

Example of a typical asynchronous operation flow:

void _theoretical_frobnitz_async(const Glib::RefPtr<Theoretical>& t,
const SlotAsyncReady& slot);
gboolean _theoretical_frobnitz_finish(const Glib::RefPtr<Theoretical>& t,
const Glib::RefPtr<AsyncResult>& result);
static void
on_frobnitz_result(Glib::RefPtr<AsyncResult>& result)
{
Glib::RefPtr<Glib::Object> source_object = result->get_source_object();
bool success = _theoretical_frobnitz_finish(source_object, res);
if (success)
std::cout << "Hurray" << std::endl;
else
std::cout << "Uh oh!" << std::endl;
...
}
int main (int argc, void *argv[])
{
...
_theoretical_frobnitz_async (theoretical_data,
sigc::ptr_fun(&on_frobnitz_result) );
...
}

The async function could also take an optional Glib::Cancellable object, allowing the calling function to cancel the asynchronous operation.

The callback for an asynchronous operation is called only once, and is always called, even in the case of a cancelled operation. On cancellation the result is a ERROR_CANCELLED error.

Some ascynchronous operations are implemented using synchronous calls. These are run in a separate GThread, but otherwise they are sent to the Main Event Loop and processed in an idle function. So, if you truly need asynchronous operations, make sure to initialize GThread.

Since glibmm 2.16:

## Constructor & Destructor Documentation

Gio::AsyncResult::AsyncResult | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::AsyncResult::~AsyncResult | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::AsyncResult::add_interface | ( | GType | gtype_implementer | ) |
| static

Glib::RefPtr<Glib::Object> Gio::AsyncResult::get_source_object | ( |  | ) |

Gets the source object from a AsyncResult.

Deprecated:
  Use get_source_object_base()

Returns
  A new reference to the source object for the res, or `0` if there is none.

Glib::RefPtr<const Glib::Object> Gio::AsyncResult::get_source_object | ( |  | ) | const

Gets the source object from a AsyncResult.

Deprecated:
  Use get_source_object_base()

Returns
  A new reference to the source object for the res, or `0` if there is none.

Glib::RefPtr<Glib::ObjectBase> Gio::AsyncResult::get_source_object_base | ( |  | ) |

Glib::RefPtr<const Glib::ObjectBase> Gio::AsyncResult::get_source_object_base | ( |  | ) | const

virtual Glib::RefPtr<Glib::ObjectBase> Gio::AsyncResult::get_source_object_vfunc | ( |  | ) |
| virtual

static GType Gio::AsyncResult::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GAsyncResult* Gio::AsyncResult::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GAsyncResult* Gio::AsyncResult::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

bool Gio::AsyncResult::is_tagged | ( | gpointer | source_tag | ) | const

Checks if res has the given source_tag (generally a function pointer indicating the function res was created by).

Since glibmm 2.34:

Parameters

  source_tag | An application-defined tag.

Returns
  `true` if res has the indicated source_tag, `false` if not.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::AsyncResult > wrap | ( | GAsyncResult * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.